/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nicstyledef_gecko.js
 * 	FCKStyleDef Class: represents a single stylke definition. (Gecko specific)
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-11-22 11:09:45
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

NICStyleDef.prototype.ApplyToSelection = function()
{
	if ( NICSelection.GetType() == 'Text' && !this.IsObjectElement )
	{
		var oSelection = NIC.EditorWindow.getSelection() ;
		
		// Create the main element.
		var e = NIC.EditorDocument.createElement( this.Element ) ;
		
		for ( var i = 0 ; i < oSelection.rangeCount ; i++ )
		{
			e.appendChild( oSelection.getRangeAt(i).extractContents() ) ;
		}
		
		// Set the attributes.
		this._AddAttributes( e ) ;
		
		// Remove the duplicated elements.
		this._RemoveDuplicates( e ) ;

		var oRange = oSelection.getRangeAt(0) ;		
		oRange.insertNode( e ) ;
	}
	else
	{
		var oControl = NICSelection.GetSelectedElement() ;
		if ( oControl.tagName == this.Element )
			this._AddAttributes( oControl ) ;
	}
}

NICStyleDef.prototype._AddAttributes = function( targetElement )
{
	for ( var a in this.Attributes )
		targetElement.setAttribute( a, this.Attributes[a], 0 ) ;
}

NICStyleDef.prototype._RemoveDuplicates = function( parent )
{
	for ( var i = 0 ; i < parent.childNodes.length ; i++ )
	{
		var oChild = parent.childNodes[i] ;
		
		if ( oChild.nodeType != 1 )
			continue ;
		
		this._RemoveDuplicates( oChild ) ;
		
		if ( this.IsEqual( oChild ) )
			NICTools.RemoveOuterTags( oChild ) ;
	}
}

NICStyleDef.prototype.IsEqual = function( e )
{
	if ( e.tagName != this.Element )
		return false ;
	
	for ( var a in this.Attributes )
	{
		if ( e.getAttribute( a ) != this.Attributes[a] )
			return false ;
	}
	
	return true ;
}

NICStyleDef.prototype._RemoveMe = function( elementToCheck )
{
	if ( ! elementToCheck )
		return ;

	var oParent = elementToCheck.parentNode ;

	if ( elementToCheck.nodeType == 1 && this.IsEqual( elementToCheck ) )
	{
		if ( this.IsObjectElement )
		{
			for ( var a in this.Attributes )
				elementToCheck.removeAttribute( a, 0 ) ;
			return ;
		}
		else
			NICTools.RemoveOuterTags( elementToCheck ) ;
	}
	
	this._RemoveMe( oParent ) ;
}
