/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nictoolbarstylecombo.js
 * 	FCKToolbarPanelButton Class: Handles the Fonts combo selector.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-11-19 07:50:11
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var NICToolbarStyleCombo = function()
{
	this.Command = NICCommands.GetCommand( 'Style' ) ;
}

// Inherit from NICToolbarSpecialCombo.
NICToolbarStyleCombo.prototype = new NICToolbarSpecialCombo ;

NICToolbarStyleCombo.prototype.GetLabel = function()
{
	return NICLang.Style ;
}

NICToolbarStyleCombo.prototype.CreateItems = function( targetSpecialCombo )
{
	// Add the Editor Area CSS to the Styles panel so the style classes are previewed correctly.
	NICTools.AppendStyleSheet( targetSpecialCombo._Panel.Document, NICConfig.EditorAreaCSS ) ;

	// For some reason Gecko is blocking inside the "RefreshVisibleItems" function.
	if ( ! NICBrowserInfo.IsGecko )
		targetSpecialCombo.OnBeforeClick = this.RefreshVisibleItems ;

	// Add the styles to the special combo.
	for ( var s in this.Command.Styles )
	{
		var oStyle = this.Command.Styles[s] ;
		if ( oStyle.IsObjectElement )
			var oItem = targetSpecialCombo.AddItem( s, s ) ;
		else
			var oItem = targetSpecialCombo.AddItem( s, oStyle.GetOpenerTag() + s + oStyle.GetCloserTag() ) ;
		oItem.Style = oStyle ;
	}
}

NICToolbarStyleCombo.prototype.RefreshActiveItems = function( targetSpecialCombo )
{
	// Clear the actual selection.
	targetSpecialCombo.DeselectAll() ;
	
	// Get the active styles.
	var aStyles = this.Command.GetActiveStyles() ;
	
	if ( aStyles.length > 0 )
	{
		// Select the active styles in the combo.
		for ( var i = 0 ; i < aStyles.length ; i++ )
			targetSpecialCombo.SelectItem( aStyles[i].Name ) ;

		// Set the combo label to the first style in the collection.
		targetSpecialCombo.SetLabelById( aStyles[0].Name ) ;
	}
	else
		targetSpecialCombo.SetLabel('') ;
}

NICToolbarStyleCombo.prototype.RefreshVisibleItems = function( targetSpecialCombo )
{
	if ( NICSelection.GetType() == 'Control' )
		var sTagName = NICSelection.GetSelectedElement().tagName ;

	for ( var i in targetSpecialCombo.Items )
	{
		var oItem = targetSpecialCombo.Items[i] ;
		if ( ( sTagName && oItem.Style.Element == sTagName ) || ( ! sTagName && ! oItem.Style.IsObjectElement ) )
			oItem.style.display = '' ;
		else
			oItem.style.display = 'none' ;	// For some reason Gecko is blocking here.
	}
}
