/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nic_1_gecko.js
 * 	This is the first part of the "FCK" object creation. This is the main
 * 	object that represents an editor instance.
 * 	(Gecko specific implementations)
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-15 13:26:29
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

NIC.Description = "NICEditor for Gecko Browsers" ;

NIC.InitializeBehaviors = function()
{
	// Disable Right-Click
	var oOnContextMenu = function( e )
	{
		e.preventDefault() ;
		NIC.ShowContextMenu( e.clientX, e.clientY ) ;
	}
	this.EditorDocument.addEventListener( 'contextmenu', oOnContextMenu, true ) ;

	var oOnKeyDown = function( e )
	{
		if ( e.ctrlKey && !e.shiftKey && !e.altKey )
		{
			// Char 86/118 = V/v
			if ( e.which == 86 || e.which == 118 )
			{
				if ( NIC.Status == NIC_STATUS_COMPLETE )
				{
					if ( !NIC.Events.FireEvent( "OnPaste" ) )
						e.preventDefault() ;
				}
				else
					e.preventDefault() ;
			}
		}
	}
	this.EditorDocument.addEventListener( 'keydown', oOnKeyDown, true ) ;
	
	var oOnSelectionChange = function( e )
	{
		/*
		var bIsDifferent = false ;
		var oActualSel = NIC.EditorWindow.getSelection() ;

		if ( NIC.LastSelection )
		{
			if ( NIC.LastSelection.rangeCount != oActualSel.rangeCount )
			{
				bIsDifferent = true ;
			}
			else
			{
				if ( oActualSel.rangeCount == 1 )
				{
					var oRangeA = oActualSel.getRangeAt(0) ;
					var oRangeB = NIC.LastSelection.getRangeAt(0) ;
					
					NICDebug.Output( 'collapsed: ' + oRangeA.collapsed ) ;
					if ( oRangeA.collapsed )
					{
						NICDebug.Output( 'startContainerBranch: ' + oRangeA.startContainerBranch + ' == ' + oRangeB.startContainerBranch ) ;
						NICDebug.Output( 'Container: ' + oRangeA.startContainer.childNodes[ oRangeA.startOffset ] + ' == ' + oRangeB.commonAncestorContainer.parent ) ;
						if 
						( 
							!oRangeB.collapsed ||
							oRangeA.startContainer.childNodes[ oRangeA.startOffset ] != oRangeB.startContainer.childNodes[ oRangeB.startOffset ] ||
							oRangeA.commonAncestorContainer.parent != oRangeB.commonAncestorContainer.parent )
						{
							bIsDifferent = true ;
						}
					}
					else
					{
						bIsDifferent = true ;
					}
				}
				else
				{
					bIsDifferent == true ;
				}
			}
		}
		else
		{
			bIsDifferent = true ;
		}
		
		NIC.LastSelection = oActualSel ;
		
		NICDebug.Output( 'bIsDifferent: ' + bIsDifferent ) ;
		
		if ( bIsDifferent )
		{*/
			NIC.Events.FireEvent( "OnSelectionChange" ) ;
		//}
	}
	
	this.EditorDocument.addEventListener( 'mouseup', oOnSelectionChange, false ) ;
	this.EditorDocument.addEventListener( 'keyup', oOnSelectionChange, false ) ;

	this.MakeEditable() ;

	this.SetStatus( NIC_STATUS_ACTIVE ) ;
}

NIC.MakeEditable = function()
{
	this.EditorDocument.designMode = 'on' ;

	// Tell Gecko to use or not the <SPAN> tag for the bold, italic and underline.
	this.EditorDocument.execCommand( 'useCSS', false, !NICConfig.GeckoUseSPAN ) ;
}

NIC.Focus = function()
{
	try
	{
		NIC.EditorWindow.focus() ;
	}
	catch(e) {}
}

NIC.SetHTML = function( html, forceWYSIWYG )
{
	if ( forceWYSIWYG || NIC.EditMode == NIC_EDITMODE_WYSIWYG )
	{
		// On Gecko we must disable editing before setting the innerHTML.
//		NIC.EditorDocument.designMode = "off" ;

		NIC.EditorDocument.body.innerHTML = html ;
	
		// On Gecko we must set the desingMode on again after setting the innerHTML.
//		NIC.EditorDocument.designMode = 'on' ;
			
		// Tell Gecko to use or not the <SPAN> tag for the bold, italic and underline.
//		NIC.EditorDocument.execCommand( "useCSS", false, !NICConfig.GeckoUseSPAN ) ;
	}
	else
		document.getElementById('eSourceField').value = html ;
}

