/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nic_1_ie.js
 * 	This is the first part of the "FCK" object creation. This is the main
 * 	object that represents an editor instance.
 * 	(IE specific implementations)
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-21 23:51:51
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

NIC.Description = "NICEditor for Internet Explorer 5.5+" ;

NIC.InitializeBehaviors = function()
{
	// Set the focus to the editable area when clicking in the document area.
	// TODO: The cursor must be positioned at the end.
	this.EditorDocument.onmousedown = this.EditorDocument.onmouseup = function()
	{
		NIC.Focus() ;
		
		NIC.EditorWindow.event.cancelBubble	= true ;
		NIC.EditorWindow.event.returnValue	= false ;
	}
	
	// Intercept pasting operations
	this.EditorDocument.body.onpaste = function()
	{
		if ( NIC.Status == NIC_STATUS_COMPLETE )
			return NIC.Events.FireEvent( "OnPaste" ) ;
		else
			return false ;
	}
	
	// Disable Right-Click and shows the context menu.
	this.EditorDocument.oncontextmenu = function()
	{
		var e = this.parentWindow.event ;
		NIC.ShowContextMenu( e.screenX, e.screenY ) ;
		return false ;
	}
	// Check if key strokes must be monitored.
	if ( NICConfig.UseBROnCarriageReturn || NICConfig.TabSpaces > 0 )
	{
		// Build the "TAB" key replacement.
		if ( NICConfig.TabSpaces > 0 )
		{
			window.NICTabHTML = '' ;
			for ( i = 0 ; i < NICConfig.TabSpaces ; i++ )
				window.NICTabHTML += "&nbsp;" ;
		}
	
		this.EditorDocument.onkeydown = function()
		{
			var e = NIC.EditorWindow.event ;
			
			if ( e.keyCode == 13 && NICConfig.UseBROnCarriageReturn )	// ENTER
			{
				if ( (e.ctrlKey || e.altKey || e.shiftKey) )
					return true ;
				else
				{
					// We must ignore it if we are inside a List.
					if ( NIC.EditorDocument.queryCommandState( 'InsertOrderedList' ) || NIC.EditorDocument.queryCommandState( 'InsertUnorderedList' ) )
						return true ;

					// Insert the <BR> (The &nbsp; must be also inserted to make it work)
					NIC.InsertHtml("<br>&nbsp;") ;
					
					// Remove the &nbsp;
					var oRange = NIC.EditorDocument.selection.createRange() ;
					oRange.moveStart('character',-1) ;	
					oRange.select() ;
					NIC.EditorDocument.selection.clear() ;
						
					return false ;
				}
			}
			else if ( e.keyCode == 9 && NICConfig.TabSpaces > 0 && !(e.ctrlKey || e.altKey || e.shiftKey) )	// TAB
			{
				NIC.InsertHtml( window.NICTabHTML ) ;
				return false ;
			}
			
			return true ;
		}
	}
	
	// Intercept cursor movements
	this.EditorDocument.onselectionchange = function()
	{
		NIC.Events.FireEvent( "OnSelectionChange" ) ;
	}
	
	//Enable editing
	this.EditorDocument.body.contentEditable = true ;

	this.SetStatus( NIC_STATUS_ACTIVE ) ;
}

NIC.Focus = function()
{
	try
	{
		if ( NIC.EditMode == NIC_EDITMODE_WYSIWYG )
			NIC.EditorDocument.body.focus() ;
		else
			document.getElementById('eSource').focus() ;
	}
	catch(e) {}
}

NIC.SetHTML = function( html, forceWYSIWYG )
{
	if ( forceWYSIWYG || NIC.EditMode == NIC_EDITMODE_WYSIWYG )
	{
		// TODO: Wait stable version and remove the following commented lines.
		// In IE, if you do document.body.innerHTML = '<p><hr></p>' it throws a "Unknow runtime error".
		// To solve it we must add a fake (safe) tag before it, and then remove it.
		// this.EditorDocument.body.innerHTML = '<div id="__fakeNICRemove__">&nbsp;</div>' + html.replace( NICRegexLib.AposEntity, '&#39;' ) ;
		// this.EditorDocument.getElementById('__fakeNICRemove__').removeNode(true) ;

		this.EditorDocument.body.innerHTML = '' ;
		if ( html && html.length > 0 )
			this.EditorDocument.write( html ) ;
	}
	else
		document.getElementById('eSourceField').value = html ;
}

// TODO: Wait stable version and remove the following commented lines.
/*
NIC.CheckRelativeLinks = function()
{
	// IE automatically change relative URLs to absolute, so we use a trick
	// to solve this problem (the document base points to "niceditor:".
	
	for ( var i = 0 ; i < this.EditorDocument.links.length ; i++ )
	{
		var e = this.EditorDocument.links[i] ;
		
		if ( e.href.startsWith( NIC.BaseUrl ) )
			e.href = e.href.remove( 0, NIC.BaseUrl.length ) ;
	}
	
	for ( var i = 0 ; i < this.EditorDocument.images.length ; i++ )
	{
		var e = this.EditorDocument.images[i] ;
		
		if ( e.src.startsWith( NIC.BaseUrl ) )
			e.src = e.src.remove( 0, NIC.BaseUrl.length ) ;
	}
}
*/

NIC.InsertHtml = function( html )
{
	NIC.Focus() ;
	
	// Gets the actual selection.
	var oSel = NIC.EditorDocument.selection ;
	
	// Deletes the actual selection contents.
	if ( oSel.type.toLowerCase() != "none" )
		oSel.clear() ;

	// Inset the HTML.
	oSel.createRange().pasteHTML( html ) ;
}

