/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nic_2.js
 * 	This is the second part of the "FCK" object creation. This is the main
 * 	object that represents an editor instance.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-20 14:04:21
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// This collection is used by the browser specific implementations to tell
// wich named commands must be handled separately.
NIC.RedirectNamedCommands = new Object() ;

NIC.ExecuteNamedCommand = function( commandName, commandParameter )
{
	if ( NIC.RedirectNamedCommands[ commandName ] != null )
		NIC.ExecuteRedirectedNamedCommand( commandName, commandParameter ) ;
	else
	{
		NIC.Focus() ;
		NIC.EditorDocument.execCommand( commandName, false, commandParameter ) ; 
		NIC.Events.FireEvent( 'OnSelectionChange' ) ;
	}
}

NIC.GetNamedCommandState = function( commandName )
{
	try
	{
		if ( !NIC.EditorDocument.queryCommandEnabled( commandName ) )
			return NIC_TRISTATE_DISABLED ;
		else
			return NIC.EditorDocument.queryCommandState( commandName ) ? NIC_TRISTATE_ON : NIC_TRISTATE_OFF ;
	}
	catch ( e )
	{
		return NIC_TRISTATE_OFF ;
	}
}

NIC.GetNamedCommandValue = function( commandName )
{
	var sValue = '' ;
	var eState = NIC.GetNamedCommandState( commandName ) ;
	
	if ( eState == NIC_TRISTATE_DISABLED ) 
		return null ;
	
	try
	{
		sValue = this.EditorDocument.queryCommandValue( commandName ) ;
	}
	catch(e) {}
	
	return sValue ? sValue : '' ;
}

NIC.CleanAndPaste = function( html )
{
	// Remove all SPAN tags
	html = html.replace(/<\/?SPAN[^>]*>/gi, "" );
	// Remove Class attributes
	html = html.replace(/<(\w[^>]*) class=([^ |>]*)([^>]*)/gi, "<$1$3") ;
	// Remove Style attributes
	html = html.replace(/<(\w[^>]*) style="([^"]*)"([^>]*)/gi, "<$1$3") ;
	// Remove Lang attributes
	html = html.replace(/<(\w[^>]*) lang=([^ |>]*)([^>]*)/gi, "<$1$3") ;
	// Remove XML elements and declarations
	html = html.replace(/<\\?\?xml[^>]*>/gi, "") ;
	// Remove Tags with XML namespace declarations: <o:p></o:p>
	html = html.replace(/<\/?\w+:[^>]*>/gi, "") ;
	// Replace the &nbsp;
	html = html.replace(/&nbsp;/, " " );
	// Transform <P> to <DIV>
	var re = new RegExp("(<P)([^>]*>.*?)(<\/P>)","gi") ;	// Different because of a IE 5.0 error
	html = html.replace( re, "<div$2</div>" ) ;
	
	NIC.InsertHtml( html ) ;
}

NIC.Preview = function()
{
	var oWindow = window.open( '', null, 'toolbar=yes,location=yes,status=yes,menubar=yes,scrollbars=yes,resizable=yes' ) ;
	
	var sHTML = '<html><head><link href="' + NICConfig.EditorAreaCSS + '" rel="stylesheet" type="text/css" /></head><body>' + NIC.GetHTML() + '</body></html>' ;
	
	oWindow.document.write( sHTML );
	oWindow.document.close();
		
	// TODO: The CSS of the editor area must be configurable.
	// oWindow.document.createStyleSheet( config.EditorAreaCSS );
}

NIC.SwitchEditMode = function()
{
	// Check if the actual mode is WYSIWYG.
	var bWYSIWYG = ( NIC.EditMode == NIC_EDITMODE_WYSIWYG ) ;
	
	// Display/Hide the TRs.
	document.getElementById('eWysiwyg').style.display	= bWYSIWYG ? 'none' : '' ;
	document.getElementById('eSource').style.display	= bWYSIWYG ? '' : 'none' ;

	// Update the HTML in the view output to show.
	if ( bWYSIWYG )
		document.getElementById('eSourceField').value = ( NICConfig.EnableXHTML && NICConfig.EnableSourceXHTML ? NIC.GetXHTML() : NIC.GetHTML() ) ;
	else
	{
		NIC.SetHTML( NIC.GetHTML(), true ) ;
		
		// Gecko looses the editing capabilities when hidding the IFRAME, so we must reset it.
		if ( NICBrowserInfo.IsGecko )
			NIC.MakeEditable() ;
	}

	// Updates the actual mode status.
	NIC.EditMode = bWYSIWYG ? NIC_EDITMODE_SOURCE : NIC_EDITMODE_WYSIWYG ;
	
	// Set the Focus.
	NIC.Focus() ;
	
	// Update the toolbar.
	NICToolbarSet.RefreshItemsState() ;
}


NIC.CreateElement = function( tag )
{
	var e = NIC.EditorDocument.createElement( tag ) ;
	e.setAttribute( '__NICTempLabel', '1' ) ;
	
	this.InsertElement( e ) ;
	
	var aEls = NIC.EditorDocument.getElementsByTagName( tag ) ;
	
	for ( var i = 0 ; i < aEls.length ; i++ )
	{
		if ( aEls[i].attributes['__NICTempLabel'] )
		{
			aEls[i].removeAttribute( '__NICTempLabel' ) ;
			return aEls[i] ;
		}
	}
}

