/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nic_last.js
 * 	These are the last script lines executed in the editor loading process.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-12-04 16:53:16
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// This is the last file loaded to complete the editor initialization and activation

// Just check if the document direction has been correctly applied (at nic_onload.js).
if ( NICLang && window.document.dir.toLowerCase() != NICLang.Dir.toLowerCase() )
	window.document.dir = NICLang.Dir ;
	
// Activate pasting operations.
if ( NICConfig.ForcePasteAsPlainText )
	NIC.Events.AttachEvent( "OnPaste", NIC.Paste ) ;

// Load Plugins.
if ( NICPlugins.Items.length > 0 )
{
	NICScriptLoader.OnEmpty = CompleteLoading ;
	NICPlugins.Load() ;
}
else
	CompleteLoading() ;

function CompleteLoading()
{
	// Load the Toolbar
	NICToolbarSet.Name = NICURLParams['Toolbar'] || 'Default' ;
	NICToolbarSet.Load( NICToolbarSet.Name ) ;
	NICToolbarSet.Restart() ;

	NIC.AttachToOnSelectionChange( NICToolbarSet.RefreshItemsState ) ;
	//NIC.AttachToOnSelectionChange( NICSelection._Reset ) ;

	NIC.SetStatus( NIC_STATUS_COMPLETE ) ;

	// Call the special "NICEditor_OnComplete" function that should be present in 
	// the HTML page where the editor is located.
	if ( typeof( window.parent.NICEditor_OnComplete ) == 'function' )
		window.parent.NICEditor_OnComplete( NIC ) ;
}
