/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nic_onload.js
 * 	This is the script that is called when the editor page is loaded inside
 * 	its IFRAME. It's the editor startup.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-11-30 11:38:24
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// Disable the context menu in the editor (areas outside the editor area).
window.document.oncontextmenu = function( e )
{
	if ( e )
		e.preventDefault() ;	// This is the Gecko way to do that.
	return false ;				// This is the IE way to do that.
}

// Gecko browsers doens't calculate well that IFRAME size so we must 
// recalculate it every time the window size changes.
if ( ! NICBrowserInfo.IsIE )
{
	window.onresize = function()
	{
		var oFrame = document.getElementById('eEditorArea') ;
		oFrame.height = 0 ;

		var oCell = document.getElementById( NIC.EditMode == NIC_EDITMODE_WYSIWYG ? 'eWysiwygCell' : 'eSource' ) ;	
		var iHeight = oCell.offsetHeight ;
		
		oFrame.height = iHeight - 2 ;
	}
}

// Start the editor as soon as the window is loaded.
window.onload = function()
{
	// There is a bug on Netscape when rendering the frame. It goes over the 
	// right border. So we must correct it.
	if ( NICBrowserInfo.IsNetscape )
		document.getElementById('eWysiwygCell').style.paddingRight = '2px' ;
	
	NICScriptLoader.OnEmpty = function()
	{
		NICScriptLoader.OnEmpty = null ;

		// Override the configurations passed throw the hidden field.
		NICConfig.LoadHiddenField() ;
		
		// Load the custom configurations file (if defined).
		if ( NICConfig.CustomConfigurationsPath.length > 0 )
			NICScriptLoader.AddScript( NICConfig.CustomConfigurationsPath ) ;
		
		// Load the styles for the configured skin.
		LoadStyles() ;
	}

	// First of all load the configuration file.
	NICScriptLoader.AddScript( '../nicconfig.js' ) ;
}

function LoadStyles()
{
	NICScriptLoader.OnEmpty = LoadScripts ;

	// Load the active skin CSS.
	NICScriptLoader.AddScript( NICConfig.SkinPath + 'nic_editor.css' ) ;
	NICScriptLoader.AddScript( NICConfig.SkinPath + 'nic_contextmenu.css' ) ;
}

function LoadScripts()
{
	NICScriptLoader.OnEmpty = null ;
	
	
	if ( NICBrowserInfo.IsIE )
		NICScriptLoader.AddScript( 'js/niceditorcode_ie_1.js' ) ;
	else
		NICScriptLoader.AddScript( 'js/niceditorcode_gecko_1.js' ) ;
}

function LoadLanguageFile()
{
	NICScriptLoader.OnEmpty = function()
	{
		// Removes the OnEmpty listener.
		NICScriptLoader.OnEmpty = null ;
		
		// Correct the editor layout to the correct language direction.
		if ( NICLang )
			window.document.dir = NICLang.Dir ;
		
		// Starts the editor.
		NIC.StartEditor() ;
	}
	
	NICScriptLoader.AddScript( 'lang/' + NICLanguageManager.ActiveLanguage.Code + '.js' ) ;
}
