/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nicselection_ie.js
 * 	Active selection functions. (IE specific implementation)
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-11-18 01:36:23
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

// Get the selection type.
NICSelection.GetType = function()
{
	return NIC.EditorDocument.selection.type ;
}

// Retrieves the selected element (if any), just in the case that a single 
// element (object like and image or a table) is selected.
NICSelection.GetSelectedElement = function()
{
	if ( this.GetType() == 'Control' )
	{
		var oRange = NIC.EditorDocument.selection.createRange() ;
		
		if ( oRange && oRange.item )
			return NIC.EditorDocument.selection.createRange().item(0) ;
	}
}

NICSelection.GetParentElement = function()
{
	if ( this.GetType() == 'Control' )
		return NICSelection.GetSelectedElement().parentElement ;
	else
		return NIC.EditorDocument.selection.createRange().parentElement() ;
}

NICSelection.MoveToNode = function( node )
{
	NIC.EditorDocument.selection.empty() ;
	var oRange = NIC.EditorDocument.selection.createRange() ;
	oRange.moveToElementText( node ) ;
	oRange.select() ;
}

// The "nodeTagName" parameter must be Upper Case.
NICSelection.HasAncestorNode = function( nodeTagName )
{
	var oContainer ;
	
	if ( NIC.EditorDocument.selection.type == "Control" )
	{
		oContainer = this.GetSelectedElement() ;
	}
	else
	{
		var oRange  = NIC.EditorDocument.selection.createRange() ;
		oContainer = oRange.parentElement() ;
	}

	while ( oContainer )
	{
		if ( oContainer.tagName == nodeTagName ) return true ;
		oContainer = oContainer.parentNode ;
	}

	return false ;
}

// The "nodeTagName" parameter must be Upper Case.
NICSelection.MoveToAncestorNode = function( nodeTagName )
{
	var oNode ;
	
	if ( NIC.EditorDocument.selection.type == "Control" )
	{
		var oRange = NIC.EditorDocument.selection.createRange() ;
		for ( i = 0 ; i < oRange.length ; i++ )
		{
			if (oRange(i).parentNode)
			{
				oNode = oRange(i).parentNode ;
				break ;
			}
		}
	}
	else
	{
		var oRange  = NIC.EditorDocument.selection.createRange() ;
		oNode = oRange.parentElement() ;
	}

	while ( oNode && oNode.nodeName != nodeTagName )
		oNode = oNode.parentNode ;
	
	return oNode ;
}

NICSelection.Delete = function()
{
	// Gets the actual selection.
	var oSel = NIC.EditorDocument.selection ;
	
	// Deletes the actual selection contents.
	if ( oSel.type.toLowerCase() != "none" )
	{
		oSel.clear() ;
	}
	
	return oSel ;
}
