/*
 * This is NICEditor, by Tim Koop
 *
 * No warrenty whatsoever comes with it.
 * NICEditor is based on:
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2004 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.timkoop.com/niceditor
 * 
 * File Name: nictoolbaritems.js
 * 	Toolbar items definitions.
 * 
 * Version:  2.0 RC2a
 * Modified: 2005-02-06 15:37:05 (nicified by Tim)
 *           2004-11-23 19:42:05
 * 
 * File Authors:
 * 		Tim Koop (nice at timkoop dot com)
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

var NICToolbarItems = new Object() ;
NICToolbarItems.LoadedItems = new Object() ;

NICToolbarItems.RegisterItem = function( itemName, item )
{
	this.LoadedItems[ itemName ] = item ;
}

NICToolbarItems.GetItem = function( itemName )
{
	var oItem = NICToolbarItems.LoadedItems[ itemName ] ;
	
	if ( oItem )
		return oItem ;

	switch ( itemName )
	{
		case 'Source'			: oItem = new NICToolbarButton( 'Source'	, NICLang.Source, null, NIC_TOOLBARITEM_ICONTEXT, true ) ; break ;
		case 'Save'				: oItem = new NICToolbarButton( 'Save'		, NICLang.Save, null, null, true  ) ; break ;
		case 'NewPage'			: oItem = new NICToolbarButton( 'NewPage'	, NICLang.NewPage, null, null, true  ) ; break ;
		case 'Preview'			: oItem = new NICToolbarButton( 'Preview'	, NICLang.Preview, null, null, true  ) ; break ;
		case 'About'			: oItem = new NICToolbarButton( 'About'		, NICLang.About ) ; break ;

		case 'Cut'				: oItem = new NICToolbarButton( 'Cut'		, NICLang.Cut, null, null, true ) ; break ;
		case 'Copy'				: oItem = new NICToolbarButton( 'Copy'		, NICLang.Copy, null, null, true ) ; break ;
		case 'Paste'			: oItem = new NICToolbarButton( 'Paste'		, NICLang.Paste, null, null, true ) ; break ;
		case 'PasteText'		: oItem = new NICToolbarButton( 'PasteText'	, NICLang.PasteText ) ; break ;
		case 'PasteWord'		: oItem = new NICToolbarButton( 'PasteWord'	, NICLang.PasteWord ) ; break ;
		case 'Print'			: oItem = new NICToolbarButton( 'Print'		, NICLang.Print, null, null, true ) ; break ;
		case 'Undo'				: oItem = new NICToolbarButton( 'Undo'		, NICLang.Undo, null, null, true ) ; break ;
		case 'Redo'				: oItem = new NICToolbarButton( 'Redo'		, NICLang.Redo, null, null, true ) ; break ;
		case 'SelectAll'		: oItem = new NICToolbarButton( 'SelectAll'	, NICLang.SelectAll, null, null, true ) ; break ;
		case 'RemoveFormat'		: oItem = new NICToolbarButton( 'RemoveFormat', NICLang.RemoveFormat ) ; break ;

		case 'Bold'				: oItem = new NICToolbarButton( 'Bold'		, NICLang.Bold ) ; break ;
		case 'Italic'			: oItem = new NICToolbarButton( 'Italic'	, NICLang.Italic ) ; break ;
		case 'Underline'		: oItem = new NICToolbarButton( 'Underline'	, NICLang.Underline ) ; break ;
		case 'StrikeThrough'	: oItem = new NICToolbarButton( 'StrikeThrough'	, NICLang.StrikeThrough ) ; break ;
		case 'Subscript'		: oItem = new NICToolbarButton( 'Subscript'		, NICLang.Subscript ) ; break ;
		case 'Superscript'		: oItem = new NICToolbarButton( 'Superscript'	, NICLang.Superscript ) ; break ;

		case 'OrderedList'		: oItem = new NICToolbarButton( 'InsertOrderedList'		, NICLang.NumberedListLbl, NICLang.NumberedList ) ; break ;
		case 'UnorderedList'	: oItem = new NICToolbarButton( 'InsertUnorderedList'	, NICLang.BulletedListLbl, NICLang.BulletedList ) ; break ;
		case 'Outdent'			: oItem = new NICToolbarButton( 'Outdent'	, NICLang.DecreaseIndent ) ; break ;
		case 'Indent'			: oItem = new NICToolbarButton( 'Indent'	, NICLang.IncreaseIndent ) ; break ;

		case 'Link'				: oItem = new NICToolbarButton( 'Link'		, NICLang.InsertLinkLbl, NICLang.InsertLink ) ; break ;
		case 'Unlink'			: oItem = new NICToolbarButton( 'Unlink'	, NICLang.RemoveLink ) ; break ;

		case 'Image'			: oItem = new NICToolbarButton( 'Image'			, NICLang.InsertImageLbl, NICLang.InsertImage ) ; break ;
		case 'Table'			: oItem = new NICToolbarButton( 'Table'			, NICLang.InsertTableLbl, NICLang.InsertTable ) ; break ;
		case 'SpecialChar'		: oItem = new NICToolbarButton( 'SpecialChar'	, NICLang.InsertSpecialCharLbl, NICLang.InsertSpecialChar ) ; break ;
		case 'Smiley'			: oItem = new NICToolbarButton( 'Smiley'		, NICLang.InsertSmileyLbl, NICLang.InsertSmiley ) ; break ;

		case 'Rule'				: oItem = new NICToolbarButton( 'InsertHorizontalRule', NICLang.InsertLineLbl, NICLang.InsertLine ) ; break ;

		case 'JustifyLeft'		: oItem = new NICToolbarButton( 'JustifyLeft'	, NICLang.LeftJustify ) ; break ;
		case 'JustifyCenter'	: oItem = new NICToolbarButton( 'JustifyCenter'	, NICLang.CenterJustify ) ; break ;
		case 'JustifyRight'		: oItem = new NICToolbarButton( 'JustifyRight'	, NICLang.RightJustify ) ; break ;
		case 'JustifyFull'		: oItem = new NICToolbarButton( 'JustifyFull'	, NICLang.BlockJustify ) ; break ;

		case 'Style'			: oItem = new NICToolbarStyleCombo() ; break ;
		case 'FontName'			: oItem = new NICToolbarFontsCombo() ; break ;
		case 'FontSize'			: oItem = new NICToolbarFontSizeCombo() ; break ;
		case 'FontFormat'		: oItem = new NICToolbarFontFormatCombo() ; break ;

		case 'TextColor'		: oItem = new NICToolbarPanelButton( 'TextColor', NICLang.TextColor ) ; break ;
		case 'BGColor'			: oItem = new NICToolbarPanelButton( 'BGColor'	, NICLang.BGColor ) ; break ;
		
		case 'Find'				: oItem = new NICToolbarButton( 'Find'		, NICLang.Find ) ; break ;
		case 'Replace'			: oItem = new NICToolbarButton( 'Replace'	, NICLang.Replace ) ; break ;
		
		default:
			alert( NICLang.UnknownToolbarItem.replace( /%1/g, itemName ) ) ;
			return ;
	}
	
	NICToolbarItems.LoadedItems[ itemName ] = oItem ;
	
	return oItem ;
}
